=begin
Copyright 2011-2014 (c) TIG  
All Rights Reserved.  
THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED   
WARRANTIES,INCLUDING,WITHOUT LIMITATION,THE IMPLIED WARRANTIES OF  
MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  
###
TIG-TextureTools_code.rb   
###
=end

module TIG
module TextureTools

### purge old version/files
def self.purger()
	### old rb
	rb = File.join(PLUGINS, "TextureRotate.rb")
	if File.exist?(rb)
		begin
			File.delete(rb)
		rescue
		end
		### image files
		[
		"TextureAdjust.png", 
		"TextureNudge.png", 
		"TextureRotate.png", 
		"TextureScale.png", 
		"TextureShunt.png", 
		"TextureTweak.png"
		].each{|f|
			img = File.join(PLUGINS, "TIGtools", f)
			if File.exist?(img)
				begin
					File.delete(img)
				rescue
				end
			end
		}
	end
	
end
self.purger()
###

class Rotate

@@angle=nil

def initialize(angle=nil)
  @@angle='90.0' unless @@angle
  @model=Sketchup.active_model
  ss=@model.selection
  face=ss[0]
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil if ! mat=face.material || ! mat.texture
  unless angle
    return nil unless anglet=self.dialog()
    angle=anglet.tr(',', '.').to_f
    if angle==0
      UI.messagebox("Angle can't be ZERO!")
      return nil unless anglet=self.dialog()
      angle=anglet.tr(',', '.').to_f
      return nil if angle==0
    end#if
    @@angle=anglet
    self.process(face, angle)
  else
    self.process(face, angle)
  end#if
end

def dialog()
  results=inputbox(["Angle [degrees]: "], [@@angle], "Texture Rotate")
  return nil unless results
  return results[0]
end

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(face=nil, angle=0.0)
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil unless mat=face.material
  return nil unless mat.texture
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  tr=Geom::Transformation.rotation(pts[0], face.normal, angle.degrees)
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
  @model.active_view.refresh
end

end#class

#==========================================================================

class Adjust
  
  @@adjust=nil
  


def initialize()
  @@adjust='1.0' unless @@adjust
  @model=Sketchup.active_model
  ss=@model.selection
  @face=ss[0]
  return nil unless @face && @face.is_a?(Sketchup::Face)
  return nil if ! @mat=@face.material || ! @mat.texture
  @msg='TextureAdjust: Angle CCW=Right-Arrow, CW=Left-Arrow, +Shift=10x'
end

def activate
  Sketchup::set_status_text('TextureAdjust: Enter Adjust Angle')
  @dialoged=false
  return nil unless aat=self.dialog()
  aa=aat.tr(',', '.').to_f
  if aa==0
    UI.messagebox("Angle can't be ZERO!")
    return nil unless aat=self.dialog()
    aa=aat.tr(',', '.').to_f
    return nil if aa==0
  end#if
  @@adjust=aat
  @d=aa
  @shift=false
  self.reset()
end

def reset()
  Sketchup::set_status_text(@msg)
  @dialoged=true
end

def deactivate(view)
  view.invalidate
end

def onCancel(flag, view)
  view.invalidate
  self.activate()
end

def onKeyUp(key,rpt,flags,view)
  if @dialoged
    @shift=false if key==VK_SHIFT
  end
end

def onKeyDown(key,rpt,flags,view)
  if @dialoged
    if key==VK_SHIFT
      @shift=true  
    else
     case key 
      when VK_LEFT
        if @shift
          self.process(-@d*10)
        else
          self.process(-@d)
        end
        self.reset()
      when VK_RIGHT
        if @shift
          self.process(@d*10)
        else
          self.process(@d)
        end
        self.reset()
     end#case
    end#if
  end#if
  
end#def

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(angle=nil)
  face=@face
  mat=@mat
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil unless mat=face.material
  return nil unless tex=mat.texture
  return nil if ! angle || angle==0
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  tr=Geom::Transformation.rotation(pts[0], face.normal, angle.degrees)
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
  @model.active_view.refresh
end

def resume(view)
  Sketchup::set_status_text(@msg)
end

def dialog()
  results=inputbox(["Angle [degrees]: "], [@@adjust], "Texture Adjust")
  return nil unless results
  return results[0]
end

end#class
#==========================================================================

class Shunt

@@u=nil
@@v=nil

def initialize(u=nil,v=nil)### u and v are strings
  @@u='1' unless @@u
  @@v='1' unless @@v
  @model=Sketchup.active_model
  ss=@model.selection
  face=ss[0]
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil if ! mat=face.material || ! mat.texture
  if ! u || ! v
    uv=self.dialog()
    return nil unless uv
    ut=uv[0]
    return nil if ! ut || ut==""
    vt=uv[1]
    return nil if ! vt || vt==""
    u=ut.tr(',', '.')
    v=vt.tr(',', '.')
    @@u=ut
    @@v=vt
    self.process(face, u, v)
  else
    u=u.to_s.tr(',', '.')
    v=v.to_s.tr(',', '.')
    self.process(face, u, v)
  end#if
end

def dialog()
  u=@@u
  v=@@v
  results=inputbox(["U: ", "V: "], [u, v], "Texture Shunt")
  return nil unless results
  return results
end

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(face=nil, u=nil, v=nil)
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil unless mat=face.material
  return nil unless tex=mat.texture
  return nil if ! u || ! v
  begin
    u=u.to_l
  rescue
    u=u.tr('.', ',').to_l
    rescue
      return nil
  end
  begin
    v=v.to_l
  rescue
    v=v.tr('.', ',').to_l
    rescue
      return nil
  end
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  tx=Geom::Transformation.translation(vx)
  ty=Geom::Transformation.translation(vy)
  tr=tx * ty
  ###
  tpts=[]
  (0..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
  @model.active_view.refresh
end

end#class

#==========================================================================

class Nudge

@@nudge=nil

def initialize()
  @@nudge='1' unless @@nudge
  @model=Sketchup.active_model
  ss=@model.selection
  @face=ss[0]
  return nil unless @face && @face.is_a?(Sketchup::Face)
  return nil if ! @mat=@face.material || ! @mat.texture
  @msg='TextureNudge: U/X=Left/Right-Arrows, V/Y=Up/Down-Arrows, +Shift=10x'
end

def activate
  Sketchup::set_status_text('TextureNudge: Enter Increment Length')
  @dialoged=false
  return nil unless dt=self.dialog()
  d=dt.tr(',', '.')
  @@nudge=dt
  @shift=false
  begin
    @d=d.to_l
  rescue
    @d=d.tr('.', ',').to_l
    rescue
      return nil
  end
  self.reset()
end

def reset()
  Sketchup::set_status_text(@msg)
  @dialoged=true
end

def deactivate(view)
  view.invalidate
end

def onCancel(flag, view)
  view.invalidate
  self.activate()
end

def onKeyUp(key,rpt,flags,view)
  if @dialoged
    @shift=false if key==VK_SHIFT
  end
end

def onKeyDown(key,rpt,flags,view)
  if @dialoged
    if key==VK_SHIFT
      @shift=true  
    else
     case key 
      when VK_LEFT
        if @shift
          self.process(-@d*10, 0)
        else
          self.process(-@d, 0)
        end
        self.reset()
      when VK_RIGHT
        if @shift
          self.process(@d*10, 0)
        else
          self.process(@d, 0)
        end
        self.reset()
      when VK_UP
        if @shift
          self.process(0, @d*10)
        else
          self.process(0, @d)
        end
        self.reset()
      when VK_DOWN
        if @shift
          self.process(0, -@d*10)
        else
          self.process(0, -@d)
        end
        self.reset()
     end#case
    end#if
  end#if
  
end#def

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(u=nil, v=nil)
  face=@face
  mat=@mat
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil unless mat=face.material
  return nil unless tex=mat.texture
  return nil if ! u || ! v
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  tx=Geom::Transformation.translation(vx)
  ty=Geom::Transformation.translation(vy)
  tr=tx * ty
  ###
  tpts=[]
  (0..3).each{|i|
    tpts << pts[i].transform(tr)
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
  @model.active_view.refresh
end

def resume(view)
  Sketchup::set_status_text(@msg)
end

def dialog()
  d=@@nudge
  results=inputbox(["Increment [length]: "], [d], "Texture Nudge")
  return nil unless results
  return results[0]
end

end#class

#==========================================================================

class Scale

@@uscale=nil
@@vscale=nil

def initialize(u=nil,v=nil)
  @@uscale='0.5' unless @@uscale
  @@vscale='0.5' unless @@vscale
  @model=Sketchup.active_model
  ss=@model.selection
  face=ss[0]
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil if ! mat=face.material || ! mat.texture
  if ! u || ! v
    return nil unless uv=self.dialog()
    if uv[0]==0 || uv[1]==0
      UI.messagebox("Scale factor can't be ZERO!")
      return nil unless uv=self.dialog()
      return nil if uv[0]==0 || uv[1]==0
    end
    ut=uv[0]
    u=ut.tr(',', '.')
    vt=uv[1]
    v=vt.tr(',', '.')
    @@uscale=ut
    @@vscale=vt
    u=u.to_f
    v=v.to_f
    return nil if ! u || ! v || (u==1 && v==1)
    self.process(face, u, v)
  else
    self.process(face, u, v)
  end#if
end

def dialog()
  u=@@uscale
  v=@@vscale
  results=inputbox(["U: ", "V: "], [u, v], "Texture Scale")
  return nil unless results
  return results
end

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(face=nil, u=1.0, v=1.0)
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil unless mat=face.material
  return nil unless tex=mat.texture
  return nil if u==1.0 && v==1.0
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  ###
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    case i
      when 1
        pt=pts[0].offset(vx)
      when 2
        pt=pts[0].offset(vx)
        pt.offset!(vy)
      when 3
        pt=pts[0].offset(vy)
    end
    tpts << pt
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
  @model.active_view.refresh
end

end#class

#==========================================================================
class Tweak
  
  @@tweak=nil

def initialize()
  @@tweak='0.5' unless @@tweak
  @model=Sketchup.active_model
  ss=@model.selection
  @face=ss[0]
  return nil unless @face && @face.is_a?(Sketchup::Face)
  return nil if ! @mat=@face.material || ! @mat.texture
  @msg='TextureTweak: Scale U/X=Left/Right-Arrows +/-, V/Y=Up/Down-Arrows +/-, +Shift=10x'
end

def activate
  Sketchup::set_status_text('TextureTweak: Enter Scale Factor')
  @dialoged=false
  return nil unless sft=self.dialog()
  sf=sft.tr(',', '.').to_f
  if sf==0
    UI.messagebox("Scale factor can't be ZERO!")
    return nil unless sft=self.dialog()
    sf=sft.tr(',', '.').to_f
    return nil if sf==0
  end#if
  @@tweak=sft
  @d=sf
  @shift=false
  self.reset()
end

def reset()
  Sketchup::set_status_text(@msg)
  @dialoged=true
end

def deactivate(view)
  view.invalidate
end

def onCancel(flag, view)
  view.invalidate
  self.activate()
end

def onKeyUp(key,rpt,flags,view)
  if @dialoged
    @shift=false if key==VK_SHIFT
  end
end

def onKeyDown(key,rpt,flags,view)
  if @dialoged
    if key==VK_SHIFT
      @shift=true  
    else
     case key 
      when VK_LEFT
        if @shift
          self.process(1/-@d*10, 1)
        else
          self.process(1/-@d, 1)
        end
        self.reset()
      when VK_RIGHT
        if @shift
          self.process(@d*10, 1)
        else
          self.process(@d, 1)
        end
        self.reset()
      when VK_UP
        if @shift
          self.process(1, @d*10)
        else
          self.process(1, @d)
        end
        self.reset()
      when VK_DOWN
        if @shift
          self.process(1, 1/-@d*10)
        else
          self.process(1, 1/-@d)
        end
        self.reset()
     end#case
    end#if
  end#if
  
end#def

def normalizeUVQ(uvq)
    uvq[0] /= uvq[2]
    uvq[1] /= uvq[2]
    uvq[2] = 1.0
    return uvq
end

def process(u=nil, v=nil)
  face=@face
  mat=@mat
  return nil unless face && face.is_a?(Sketchup::Face)
  return nil unless mat=face.material
  return nil unless tex=mat.texture
  return nil if ! u || ! v
  ###
  tw=Sketchup.create_texture_writer
  samples=[face.outer_loop.vertices[0].position]  ### 0,0 | Origin
  samples << samples[0].offset(face.normal.axes.x)### 1,0 | Offset Origin in X
  samples << samples[1].offset(face.normal.axes.y)### 1,1 | Offset X in Y
  samples << samples[0].offset(face.normal.axes.y)### 0,1 | Offset Origin in Y
  pts=[]### Array containing 3D points.
  uvs=[]### Array containing UV points.
  uvh=face.get_UVHelper(true, false, tw)
  samples.each{|pt|
    pts << pt                                      ### XYZ 3D coordinates 
    uvs << self.normalizeUVQ(uvh.get_front_UVQ(pt))### UVQ 2D coordinates
  }
  ###
  vx=Geom::Vector3d.new(u,0,0)
  vy=Geom::Vector3d.new(0,v,0)
  tt=Geom::Transformation.new(pts[0], face.normal)
  vx.transform!(tt)
  vy.transform!(tt)
  ###
  tpts=[pts[0], uvs[0]]
  (1..3).each{|i|
    case i
      when 1
        pt=pts[0].offset(vx)
      when 2
        pt=pts[0].offset(vx)
        pt.offset!(vy)
      when 3
        pt=pts[0].offset(vy)
    end
    tpts << pt
    tpts << uvs[i]
  }
  face.position_material(mat, tpts, true)
  @model.active_view.refresh
end

def resume(view)
  Sketchup::set_status_text(@msg)
end

def dialog()
  d=@@tweak
  results=inputbox(["Scale Factor: "], [d], "Texture Tweak")
  return nil unless results
  return results[0]
end

end#class
#==========================================================================

# menu --------------------------------------------------------------------
unless file_loaded?(__FILE__)
    ###
	IMAGES=File.join(FOLDER, "Images")
    imgpng1= File.join(IMAGES, "TextureRotate.png")
    imgpng1a=File.join(IMAGES, "TextureAdjust.png")
    imgpng2= File.join(IMAGES, "TextureShunt.png")
    imgpng3= File.join(IMAGES, "TextureNudge.png")
    imgpng4= File.join(IMAGES, "TextureScale.png")
    imgpng5= File.join(IMAGES, "TextureTweak.png")
    ###
    cmd1=UI::Command.new("TextureRotate"){TIG::TextureTools::Rotate.new()}
    cmd1a=UI::Command.new("TextureAdjust"){Sketchup.active_model.select_tool(TIG::TextureTools::Adjust.new())}
    cmd2=UI::Command.new("TextureShunt"){TIG::TextureTools::Shunt.new()}
    cmd3=UI::Command.new("TextureNudge"){Sketchup.active_model.select_tool(TIG::TextureTools::Nudge.new())}
    cmd4=UI::Command.new("TextureScale"){TIG::TextureTools::Scale.new()}
    cmd5=UI::Command.new("TextureTweak"){Sketchup.active_model.select_tool(TIG::TextureTools::Tweak.new())}
	###
    if File.exist?(imgpng1) || File.exist?(imgpng1a) || File.exist?(imgpng2) || File.exist?(imgpng3) || File.exist?(imgpng4) || File.exist?(imgpng5)
	  TOOLBAR=UI::Toolbar.new("TIG-TextureTools")
      TOOLBAR.restore if TOOLBAR.get_last_state.abs==1 # TB_VISIBLE/NEVER
    end#if
    if File.exist?(imgpng1)
	  cmd1.small_icon=imgpng1
	  cmd1.large_icon=imgpng1
      TOOLBAR.add_item(cmd1)
	end#if
    if File.exist?(imgpng1a)
	  cmd1a.small_icon=imgpng1a
	  cmd1a.large_icon=imgpng1a
      TOOLBAR.add_item(cmd1a)
	end#if
    if File.exist?(imgpng2)
	  cmd2.small_icon=imgpng2
	  cmd2.large_icon=imgpng2
      TOOLBAR.add_item(cmd2)
	end#if
    if File.exist?(imgpng3)
	  cmd3.small_icon=imgpng3
	  cmd3.large_icon=imgpng3
      TOOLBAR.add_item(cmd3)
	end#if
    if File.exist?(imgpng4)
	  cmd4.small_icon=imgpng4
	  cmd4.large_icon=imgpng4
      TOOLBAR.add_item(cmd4)
	end#if
    if File.exist?(imgpng5)
	  cmd5.small_icon=imgpng5
	  cmd5.large_icon=imgpng5
      TOOLBAR.add_item(cmd5)
	end#if
	cmd1.tooltip="TextureRotate"
	cmd1.status_bar_text="TextureRotate: Rotate a Selected Face's Texture by Angle..."
	cmd1.menu_text="TextureRotate"
	cmd1a.tooltip="TextureAdjust"
	cmd1a.status_bar_text="TextureAdjust: Adjust [Rotate] a Selected Face's Texture with the Arrow-Keys..."
	cmd1a.menu_text="TextureAdjust"
	cmd2.tooltip="TextureShunt"
	cmd2.status_bar_text="TextureShunt: Shunt a Selected Face's Texture by UV distances..."
	cmd2.menu_text="TextureShunt"
	cmd3.tooltip="TextureNudge"
	cmd3.status_bar_text="TextureNudge: Nudge a Selected Face's Texture with the Arrow-Keys..."
	cmd3.menu_text="TextureNudge"
    cmd4.tooltip="TextureScale"
	cmd4.status_bar_text="TextureScale: Scale a Selected Face's Texture in UV..."
	cmd4.menu_text="TextureScale"
	cmd5.tooltip="TextureTweak"
	cmd5.status_bar_text="TextureTweak: Tweak [Scale] a Selected Face's Texture with the Arrow-Keys..."
	cmd5.menu_text="TextureTweak"
	###
	MENU=UI.menu("Plugins").add_submenu("TIG-TextureTools...")
	MENU.add_item(cmd1)
	MENU.add_item(cmd1a)
	MENU.add_item(cmd2)
	MENU.add_item(cmd3)
	MENU.add_item(cmd4)
	MENU.add_item(cmd5)
	MENU.add_item("Toggle Toolbar ON/OFF"){(TOOLBAR.visible?) ? TOOLBAR.hide : TOOLBAR.show}
    ###
end
file_loaded(__FILE__)

end#module
end#TIG